const GraknSession = require('./GraknSession');
const messages = require("./autogenerated/grakn_pb");

module.exports = {
    session: (uri, keyspace, credentials) => new GraknSession(uri, keyspace, credentials)
}

/**
 * List of available dataTypes for Grakn Attributes
 */
module.exports.dataType = {
    STRING: messages.DataType.STRING,
    BOOLEAN: messages.DataType.BOOLEAN,
    INTEGER: messages.DataType.INTEGER,
    LONG: messages.DataType.LONG,
    FLOAT: messages.DataType.FLOAT,
    DOUBLE: messages.DataType.DOUBLE,
    DATE: messages.DataType.DATE
};

/**
 * List of available transaction types supported by Grakn
 */
module.exports.txType = {
    READ: messages.TxType.READ,
    WRITE: messages.TxType.WRITE,
    BATCH: messages.TxType.BATCH
};