const messages = require("../../autogenerated/grakn_pb");

function DeleteService(stub) {
    this.stub = stub;
}

DeleteService.prototype.delete = function (keyspace) {
    const openRequest = new messages.Open();
    const deleteRequest = new messages.DeleteRequest();
    const messageKeyspace = new messages.Keyspace();
    messageKeyspace.setValue(keyspace);
    openRequest.setKeyspace(messageKeyspace);
    openRequest.setTxtype(messages.TxType.WRITE);
    deleteRequest.setOpen(openRequest);
    return new Promise((resolve, reject) => {
        this.stub.delete(deleteRequest, (err) => {
            if (err) reject(err);
            else resolve();
        });
    })
}

module.exports = DeleteService;